﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace AdornmentLayerCSharp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ShapeFileFeatureLayer USLayer = new ShapeFileFeatureLayer("..\\..\\Data\\USStates.shp");
            USLayer.Name = "Unit States";
            USLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            USLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay usOverlay = new LayerOverlay();
            usOverlay.Name = "US Overlay";
            usOverlay.Layers.Add(USLayer);
            winformsMap1.Overlays.Add(usOverlay);

            InMemoryFeatureLayer tempLayer1 = new InMemoryFeatureLayer();
            LineShape tempLine = new LineShape();
            tempLine.Vertices.Add(new Vertex(-140, 60));
            tempLine.Vertices.Add(new Vertex(-80, 0));

            tempLayer1.InternalFeatures.Add(new Feature(tempLine));
            tempLayer1.Name = "TempLayer1";
            tempLayer1.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = LineStyles.CreateSimpleLineStyle(GeoColor.StandardColors.Red, 3, true);
            tempLayer1.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            InMemoryFeatureLayer tempLayer2 = new InMemoryFeatureLayer();
            tempLayer2.InternalFeatures.Add(new Feature(-85, 0));
            tempLayer2.Name = "TempLayer2";
            tempLayer2.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City1;
            tempLayer2.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay tempOverlay = new LayerOverlay();
            tempOverlay.Name = "Temp Overlay";
            tempOverlay.Layers.Add(tempLayer1);
            tempOverlay.Layers.Add(tempLayer2);

            winformsMap1.Overlays.Add(tempOverlay);

            LegendAdornmentLayer textAdornmentLayer = new LegendAdornmentLayer(10.0f, 10.0f, winformsMap1.Overlays);
            winformsMap1.AdornmentOverlay.Layers.Add(textAdornmentLayer);

            ScaleLineAdornmentLayer scaleBarAdornmentLayer = new ScaleLineAdornmentLayer(AdornmentLocation.LowerLeft);
            winformsMap1.AdornmentOverlay.Layers.Add(scaleBarAdornmentLayer);

            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            winformsMap1.CurrentExtent = new RectangleShape(-140, 60, -80, 0);
            winformsMap1.Refresh();
        }
    }
}
